//      count_main_loop.c
//
//      Copyright 2010 Petr Zikán <ziki@.cz>
//
//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 3 of the License, or
//      (at your option) any later version.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.
// hlavni casova smycka


#include "nteles.h"

void count_clear(void) {
   for (i=0; i<=MAXINDEX; i++) {
      F[i][0] = 0;
      F[i][1] = 0;
      F[i][2] = 0;
   }
}


void count_forces(void) {

float r, r2, rx, ry, rz;
float Fx = 0, Fy = 0, Fz = 0;

for (i=0; i<=MAXINDEX-1; i++) {
   for (j=i+1; j<=MAXINDEX; j++) {

      rx = -(poloha[i][0] - poloha[j][0]);
      ry = -(poloha[i][1] - poloha[j][1]);
      rz = -(poloha[i][2] - poloha[j][2]);

      r = sqrt(rx*rx + ry*ry + rz*rz);       // norma vektoru
      r2 = r*r;

      // jednotkovy vektor ve smeru sily:
      rx = rx/r;
      ry = ry/r;
      rz = rz/r;

      // pricte silu od j-teho telesa:
      Fx = G_AU*m[i]*m[j]*rx / r2;
      Fy = G_AU*m[i]*m[j]*ry / r2;
      Fz = G_AU*m[i]*m[j]*rz / r2;

      F[i][0] = F[i][0] + Fx;
      F[j][0] = F[j][0] - Fx;

      F[i][1] = F[i][1] + Fy;
      F[j][1] = F[j][1] - Fy;

      F[i][2] = F[i][2] + Fz;
      F[j][2] = F[j][2] - Fz;

   }; // konec j-cyklu

}; // konec i-cyklu

}

void count_integrator(void) {

   for(i=0; i<=MAXINDEX; i++) {
      rychlost[i][0] = rychlost[i][0] + (F[i][0]/m[i])*KROK;
      rychlost[i][1] = rychlost[i][1] + (F[i][1]/m[i])*KROK;
      rychlost[i][2] = rychlost[i][2] + (F[i][2]/m[i])*KROK;

      poloha[i][0] = poloha[i][0] + rychlost[i][0]*KROK;
      poloha[i][1] = poloha[i][1] + rychlost[i][1]*KROK;
      poloha[i][2] = poloha[i][2] + rychlost[i][2]*KROK;
   };
}
